package com.example.venue_reservation_service.service;

import com.example.venue_reservation_service.domain.Information;
import com.baomidou.mybatisplus.extension.service.IService;
import com.example.venue_reservation_service.domain.Price;
import com.example.venue_reservation_service.dto.*;
import com.example.venue_reservation_service.vo.Result;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.core.io.InputStreamResource;
import org.springframework.http.ResponseEntity;
import org.springframework.web.multipart.MultipartFile;

import java.io.InputStream;
import java.util.List;

/**
* @author 31586
* @description 针对表【venue_information】的数据库操作Service
* @createDate 2024-11-12 21:43:55
*/
public interface InformationService extends IService<Information> {


    Result getTypes(PageDTO dto);

    Result getDetails(Integer typeId);

    Result getInformation(InformationDTO dto);

    Result addInformation(Information information);

    Result updateInformation(Information information);

    Result delInformation(Integer id);

    Result updatePrice(Price price);

    Result classifyInformation(TypeDTO dto);

    Result getConditions(QueryDTO dto);

    Result viewInformation(ViewDTO dto);

    List<Integer> getIdsByTypeId(Integer typeId);

    Result upload(Integer id, MultipartFile file);

    Result queryTypes();

    Result adminMessage(SQueryDTO dto);

    ResponseEntity<InputStreamResource> QRDownload(Integer id, HttpServletResponse response);

}
