package com.example.venue_reservation_service.service;

import com.example.venue_reservation_service.domain.Slot;
import com.baomidou.mybatisplus.extension.service.IService;
import com.example.venue_reservation_service.dto.PageDTO;
import com.example.venue_reservation_service.dto.SQueryDTO;
import com.example.venue_reservation_service.dto.UserDTO;
import com.example.venue_reservation_service.vo.Result;

import java.util.List;

/**
* @author 31586
* @description 针对表【venue_slot(管理员禁用场地记录表)】的数据库操作Service
* @createDate 2024-12-23 18:34:08
*/
public interface SlotService extends IService<Slot> {


    Result getStatus(SQueryDTO dto);

    Result querySlots(UserDTO dto);

    Result delSlot(Integer slotId, Integer userId);

    Result pageSlots(PageDTO dto);

    Result slotVenues(Integer id);

    // 超级管理员添加禁用时间段
    Result createSlot(Slot slot);

    Result setSlots(List<Integer> venueIds, Integer slotId);

    Result inquireMsg(Integer slotId);

    Result removeSlot(Integer vId, Integer sId);

}
