package com.example.venue_reservation_service.utils;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.web.multipart.MultipartFile;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Base64;

public class QRCodeGenerator {

    public static MultipartFile generateQRCode(String content) {
        String qrCodeBase64 = null;
        try {
            // 设置二维码参数
             int width = 300;
             int height = 300;
            String charset = "UTF-8";
            // 使用zxing库生成二维码图片
            QRCodeWriter qrCodeWriter = new QRCodeWriter();
            BitMatrix bitMatrix = qrCodeWriter.encode(content, BarcodeFormat.QR_CODE, width, height);
            // 将BitMatrix转换为BufferedImage
            BufferedImage bufferedImage = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
            bufferedImage.createGraphics();
            Graphics2D graphics = (Graphics2D) bufferedImage.getGraphics();
            graphics.setColor(Color.WHITE);
            graphics.fillRect(0, 0, width, height);
            graphics.setColor(Color.BLACK);
            for (int i = 0; i < width; i++) {
                for (int j = 0; j < height; j++) {
                    if (bitMatrix.get(i, j)) {
                        graphics.fillRect(i, j, 1, 1);
                    }
                }
            }

            // 将BufferedImage转换为Base64编码
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            ImageIO.write(bufferedImage, "png", baos);
            byte[] bytes = baos.toByteArray();
            qrCodeBase64 = Base64.getEncoder().encodeToString(bytes);

            return new MockMultipartFile(
                    "file",           // 表单字段名
                    System.currentTimeMillis() + content + ".png",    // 文件名（后缀需与格式匹配）
                    "image/png",      // MIME类型（如image/jpeg）
                    bytes        // 字节数组
            );
        } catch (WriterException | IOException e) {
            e.printStackTrace();
        }

        return null;
    }
}
